AchievementICanSeeYou = class(Turbine.UI.Control)
function AchievementICanSeeYou:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Sneak"] = true,
        ["Hide in Plain Sight"] = true,
        ["Improved Hide in Plain Sight"] = true,
    }

    self.effectList = {
        ["Combat Stealth"] = true,
    }
    self.sneakCallback = AddCallback(ChatEventHandler, "PlayerBenefit", function(args)
        if self.skillList[args.SkillName] then
            handler:Fail("I Can See You", "You went into Stealth", 0x41007E87)
        end
    end)

    self.CDGCallback = AddCallback(PlayerEffectsHandler, "EffectAdded", function(effect)
        if self.skillList[effect:GetName()] then
            handler:Fail("I Can See You", "You went into Stealth", 0x41007E87)
        end
    end)
end

function AchievementICanSeeYou:Unload()
    RemoveCallback(PlayerEffectsHandler, "EffectAdded", self.CDGCallback)
    RemoveCallback(ChatEventHandler, "PlayerBenefit", self.sneakCallback)
end